package cachestorage

// Code generated by chromedp-gen. DO NOT EDIT.

// CacheID unique identifier of the Cache object.
type CacheID string

// String returns the CacheID as string value.
func (t CacheID) String() string {
	return string(t)
}

// DataEntry data entry.
type DataEntry struct {
	RequestURL         string    `json:"requestURL"`         // Request URL.
	RequestMethod      string    `json:"requestMethod"`      // Request method.
	RequestHeaders     []*Header `json:"requestHeaders"`     // Request headers
	ResponseTime       float64   `json:"responseTime"`       // Number of seconds since epoch.
	ResponseStatus     int64     `json:"responseStatus"`     // HTTP response status code.
	ResponseStatusText string    `json:"responseStatusText"` // HTTP response status text.
	ResponseHeaders    []*Header `json:"responseHeaders"`    // Response headers
}

// Cache cache identifier.
type Cache struct {
	CacheID        CacheID `json:"cacheId"`        // An opaque unique id of the cache.
	SecurityOrigin string  `json:"securityOrigin"` // Security origin of the cache.
	CacheName      string  `json:"cacheName"`      // The name of the cache.
}

// Header [no description].
type Header struct {
	Name  string `json:"name"`
	Value string `json:"value"`
}

// CachedResponse cached response.
type CachedResponse struct {
	Body string `json:"body"` // Entry content, base64-encoded.
}
